package body Sets is

   function Make (I : Set_Init) return Set is
      R : Set := (others => False);
   begin
      for Ii of I loop
         pragma Assert (not R (Ii));
         R (Ii) := True;
      end loop;

      return R;
   end Make;

   function Has (S : Set; V : Val_T) return Boolean
     is (S (V));

   procedure Put_Image (Output : in out Ada.Strings.Text_Buffers.Root_Buffer_Type'Class; S : Set) is
      First : Boolean := True;
   begin
      Output.Put ("[");
      for V in Val_T loop
         if S (V) then
            if not First then
               Output.Put (", ");
            end if;
            Output.Put (V'Image);
            First := False;
         end if;
      end loop;
      Output.Put ("]");
   end Put_Image;

end Sets;
