pragma Ada_2022;
with Ada.Strings.Text_Buffers;

generic
   type Val_T is (<>);
package Sets is

   type Set is private with Put_Image => Put_Image;
   procedure Put_Image (Output : in out Ada.Strings.Text_Buffers.Root_Buffer_Type'Class; S : Set);
   
   type Set_Init is array (Positive range <>) of Val_T;
   function Make (I : Set_Init) return Set;
   function Has (S : Set; V : Val_T) return Boolean;
   
private
   
   type Set is array (Val_T) of Boolean;

end Sets;
